abstract class Graphik {
	String name;

	Graphik(String str) {
		this.name = str;
	}

	String getName() {
		return this.name;
	}

	abstract void draw();
}

class Rechteck extends Graphik {
	float width, height;

	Rechteck(String str, float w, float h) {
		super(str);
		this.width = w;
		this.height = h;
	}

	// geerbt: getName
	// weitere Methoden ...
	// implementiert:
	void draw() {
		IO.println("Rechteck:" + this.name);
	}
}

class Kreis extends Graphik {
	float radius;

	Kreis(String str, float r) {
		super(str);
		this.radius = r;
	}

	// geerbt: getName
	// weitere Methoden ...
	// implementiert:
	void draw() {
		IO.println("Kreis:" + this.name);
	}
}

class Linie extends Graphik {
	float laenge;

	Linie(String str, float l) {
		super(str);
		this.laenge = l;
	}

	// implementiert:
	void draw() {
		IO.println("Linie:" + this.name);
	}
}

class Set {
	Graphik[] elems;

	int next;

	Set(int size) {
		this.elems = new Graphik[size];
		this.next = 0;
	}

	void add(Graphik obj) {
		if (this.next < this.elems.length)
			this.elems[this.next++] = obj;
	}

	Graphik[] get() {
		return this.elems;
	}
}

class GraphikProbe {
	public static void main(String[] args) {
		Rechteck r1 = new Rechteck("Rechteck 1", 10, 20);
		Kreis k1 = new Kreis("Kreis 1", 50);
		Linie l1 = new Linie("Linie 1", 40);
		Rechteck r2 = new Rechteck("Rechteck 2", 15, 15);
		// Graphik g1 = new Graphik("Graphik 1"); // Fehler!
		Set menge = new Set(6);
		menge.add(r1); // Ausnutzung der Polymorphie!
		menge.add(r2);
		menge.add(k1);
		menge.add(l1);
		Graphik[] elements = menge.get();
		for (int i = 0; i < elements.length; i++)
			if (elements[i] != null)
				elements[i].draw(); // Dynamisches Binden!
	}
}
